REM Start of BASIC! Program
REM calculate Julian Date from Gregorian date
REM s$ must be in the form of REM YYYY-MM-DD or DD-Mon-YYYY
REM Yyyy/mm/dd or mm/dd/yyyy
REM Or mm-dd-yyyy
REM otherwise just converts REM s$ to numerical value

FN.DEF julian(month, day, year)
 a=FLOOR((14-month)/12)
 y=year+4800-a
 m=month+12*a-3

 v= day + FLOOR((153*m+2)/5)+365*Y + FLOOR(y/4)-FLOOR(y/100)+FLOOR(y/400)-32045

 FN.RTN v
FN.END

FN.DEF calcdate(s$)

 s$=TRIM$(s$)
 s$=REPLACE$(s$, "/", "-")
 s$=replace$(s$,chr$(0),"")

if s$="" then fn.rtn 0
 Months$="JanFebMarAprMayJunJulAugSepOctNovDec"

 Isamonth= ( LEN(s$) >7) & IS_IN(MID$(s$,4,3),Months$)

 IF isamonth  
  Month = FLOOR(IS_IN(MID$(s$,4,3),months$)/3)+1
  Day= VAL(MID$(s$,1,2))
  Year = VAL(MID$(s$,8,4))
  FN.RTN julian(month, Day, year)
 ENDIF




 IF MID$(s$,5,1)="-" 
  Year = VAL(MID$(s$, 1,4))
  Month= VAL(MID$(s$, 6,2))
  Day= VAL(MID$(s$,9,2))
  FN.RTN julian(month, Day, year)
 ENDIF

 IF MID$(s$, 3,1)="-"
  Year = VAL(MID$(s$, 7,4))
  Month= VAL(MID$(s$, 1,2))
  Day= VAL(MID$(s$,4,2))
  FN.RTN julian(month, Day, year)
 ENDIF


 FN.RTN VAL(s$)

FN.END


FN.DEF julianToGregorian$(j)
 p = J + 68569
 q = FLOOR(4*p/146097)
 r = p - FLOOR( (146097*q + 3)/4)
 s = FLOOR(4000*(r+1)/1461001 )
 t = r - FLOOR(1461*s/4) + 31 
 u = FLOOR(80*t/2447 )
 v = FLOOR(u/11)

 Y = 100*(q-49)+s+v
 M = u + 2 - 12*v 
 D =  t - FLOOR(2447*u/80 )

 FN.RTN INT$(m)+"-"+INT$(d)+"-"+INT$(y)
FN.END


FN.DEF isdate(s$)
 S$=REPLACE$(s$, "/", "-")

 Months$="JanFebMarAprMayJunJulAugSepOctNovDec"

 Isamonth= ( LEN(s$) >7) & IS_IN(MID$(s$,4,3),Months$)

 IF isamonth  
  FN.RTN 1
 ENDIF

 IF IS_IN("-", MID$(s$, 2,8)) 
  FN.RTN 1
 ENDIF
 FN.RTN 0
FN.END

!print calcdate("2015-10-01")
!end
